FilterChain (Apache Ant API)

Package org.apache.tools.ant.types

## Class FilterChain

- java.lang.Object
- - org.apache.tools.ant.ProjectComponent
  - - org.apache.tools.ant.types.DataType
    - - org.apache.tools.ant.types.FilterChain

- All Implemented Interfaces:
    `java.lang.Cloneable`
  Direct Known Subclasses:
    `FilterMapper`

      public class FilterChain
      extends DataType

  FilterChain may contain a chained set of filter readers.

- - ### Field Summary

    - ### Fields inherited from class org.apache.tools.ant.types.DataType

      `checked, ref`

    - ### Fields inherited from class org.apache.tools.ant.ProjectComponent

      `description, location, project`

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `FilterChain()` |

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `void` | `add​(ChainableReader filter)` | Add a chainfilter filter.
    `void` | `addClassConstants​(ClassConstants classConstants)` | Add a ClassConstants filter.
    `void` | `addContainsRegex​(TokenFilter.ContainsRegex filter)` | Add a containsregex filter.
    `void` | `addDeleteCharacters​(TokenFilter.DeleteCharacters filter)` | Add a delete characters filter.
    `void` | `addEscapeUnicode​(EscapeUnicode escapeUnicode)` | Add an EscapeUnicode filter.
    `void` | `addExpandProperties​(ExpandProperties expandProperties)` | Add an ExpandProperties filter.
    `void` | `addFilterReader​(AntFilterReader filterReader)` | Add an AntFilterReader filter.
    `void` | `addHeadFilter​(HeadFilter headFilter)` | Add a HeadFilter filter.
    `void` | `addIgnoreBlank​(TokenFilter.IgnoreBlank filter)` | Add an ignoreBlank filter.
    `void` | `addLineContains​(LineContains lineContains)` | Add a LineContains filter.
    `void` | `addLineContainsRegExp​(LineContainsRegExp lineContainsRegExp)` | Add a LineContainsRegExp filter.
    `void` | `addPrefixLines​(PrefixLines prefixLines)` | Add a PrefixLines filter.
    `void` | `addReplaceRegex​(TokenFilter.ReplaceRegex filter)` | Add a replaceregex filter.
    `void` | `addReplaceString​(TokenFilter.ReplaceString filter)` | Add a replacestring filter.
    `void` | `addReplaceTokens​(ReplaceTokens replaceTokens)` | Add a ReplaceTokens filter.
    `void` | `addStripJavaComments​(StripJavaComments stripJavaComments)` | Add a StripJavaCommands filter.
    `void` | `addStripLineBreaks​(StripLineBreaks stripLineBreaks)` | Add a StripLineBreaks filter.
    `void` | `addStripLineComments​(StripLineComments stripLineComments)` | Add a StripLineComments filter.
    `void` | `addSuffixLines​(SuffixLines suffixLines)` | Add a SuffixLines filter.
    `void` | `addTabsToSpaces​(TabsToSpaces tabsToSpaces)` | Add a TabsToSpaces filter.
    `void` | `addTailFilter​(TailFilter tailFilter)` | Add a TailFilter filter.
    `void` | `addTokenFilter​(TokenFilter tokenFilter)` | Add a TokenFilter filter.
    `void` | `addTrim​(TokenFilter.Trim filter)` | Add a trim filter.
    `protected void` | `dieOnCircularReference​(java.util.Stack<java.lang.Object> stk, Project p)` | Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).
    `java.util.Vector<java.lang.Object>` | `getFilterReaders()` | Return the filters.
    `void` | `setRefid​(Reference r)` | Makes this instance in effect a reference to another FilterChain instance.

    - ### Methods inherited from class org.apache.tools.ant.types.DataType

      `checkAttributesAllowed, checkChildrenAllowed, circularReference, clone, dieOnCircularReference, dieOnCircularReference, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getCheckedRef, getDataTypeName, getRefid, invokeCircularReferenceCheck, isChecked, isReference, noChildrenAllowed, pushAndInvokeCircularReferenceCheck, setChecked, tooManyAttributes, toString`

    - ### Methods inherited from class org.apache.tools.ant.ProjectComponent

      `getDescription, getLocation, getProject, log, log, setDescription, setLocation, setProject`

    - ### Methods inherited from class java.lang.Object

      `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### FilterChain

          public FilterChain()

  - ### Method Detail

    - #### addFilterReader

          public void addFilterReader​(AntFilterReader filterReader)

      Add an AntFilterReader filter.
      Parameters:
        `filterReader` - an `AntFilterReader` value

    - #### getFilterReaders

          public java.util.Vector<java.lang.Object> getFilterReaders()

      Return the filters.
      Returns:
        a `Vector` value containing the filters

    - #### addClassConstants

          public void addClassConstants​(ClassConstants classConstants)

      Add a ClassConstants filter.
      Parameters:
        `classConstants` - a `ClassConstants` value

    - #### addExpandProperties

          public void addExpandProperties​(ExpandProperties expandProperties)

      Add an ExpandProperties filter.
      Parameters:
        `expandProperties` - an `ExpandProperties` value

    - #### addHeadFilter

          public void addHeadFilter​(HeadFilter headFilter)

      Add a HeadFilter filter.
      Parameters:
        `headFilter` - a `HeadFilter` value

    - #### addLineContains

          public void addLineContains​(LineContains lineContains)

      Add a LineContains filter.
      Parameters:
        `lineContains` - a `LineContains` value

    - #### addLineContainsRegExp

          public void addLineContainsRegExp​(LineContainsRegExp lineContainsRegExp)

      Add a LineContainsRegExp filter.
      Parameters:
        `lineContainsRegExp` - a `LineContainsRegExp` value

    - #### addPrefixLines

          public void addPrefixLines​(PrefixLines prefixLines)

      Add a PrefixLines filter.
      Parameters:
        `prefixLines` - a `PrefixLines` value

    - #### addSuffixLines

          public void addSuffixLines​(SuffixLines suffixLines)

      Add a SuffixLines filter.
      Parameters:
        `suffixLines` - a `SuffixLines` value
      Since:
        Ant 1.8.0

    - #### addReplaceTokens

          public void addReplaceTokens​(ReplaceTokens replaceTokens)

      Add a ReplaceTokens filter.
      Parameters:
        `replaceTokens` - a `ReplaceTokens` value

    - #### addStripJavaComments

          public void addStripJavaComments​(StripJavaComments stripJavaComments)

      Add a StripJavaCommands filter.
      Parameters:
        `stripJavaComments` - a `StripJavaComments` value

    - #### addStripLineBreaks

          public void addStripLineBreaks​(StripLineBreaks stripLineBreaks)

      Add a StripLineBreaks filter.
      Parameters:
        `stripLineBreaks` - a `StripLineBreaks` value

    - #### addStripLineComments

          public void addStripLineComments​(StripLineComments stripLineComments)

      Add a StripLineComments filter.
      Parameters:
        `stripLineComments` - a `StripLineComments` value

    - #### addTabsToSpaces

          public void addTabsToSpaces​(TabsToSpaces tabsToSpaces)

      Add a TabsToSpaces filter.
      Parameters:
        `tabsToSpaces` - a `TabsToSpaces` value

    - #### addTailFilter

          public void addTailFilter​(TailFilter tailFilter)

      Add a TailFilter filter.
      Parameters:
        `tailFilter` - a `TailFilter` value

    - #### addEscapeUnicode

          public void addEscapeUnicode​(EscapeUnicode escapeUnicode)

      Add an EscapeUnicode filter.
      Parameters:
        `escapeUnicode` - an `EscapeUnicode` value
      Since:
        Ant 1.6

    - #### addTokenFilter

          public void addTokenFilter​(TokenFilter tokenFilter)

      Add a TokenFilter filter.
      Parameters:
        `tokenFilter` - a `TokenFilter` value
      Since:
        Ant 1.6

    - #### addDeleteCharacters

          public void addDeleteCharacters​(TokenFilter.DeleteCharacters filter)

      Add a delete characters filter.
      Parameters:
        `filter` - a `TokenFilter.DeleteCharacters` value
      Since:
        Ant 1.6

    - #### addContainsRegex

          public void addContainsRegex​(TokenFilter.ContainsRegex filter)

      Add a containsregex filter.
      Parameters:
        `filter` - a `TokenFilter.ContainsRegex` value
      Since:
        Ant 1.6

    - #### addReplaceRegex

          public void addReplaceRegex​(TokenFilter.ReplaceRegex filter)

      Add a replaceregex filter.
      Parameters:
        `filter` - a `TokenFilter.ReplaceRegex` value

    - #### addTrim

          public void addTrim​(TokenFilter.Trim filter)

      Add a trim filter.
      Parameters:
        `filter` - a `TokenFilter.Trim` value
      Since:
        Ant 1.6

    - #### addReplaceString

          public void addReplaceString​(TokenFilter.ReplaceString filter)

      Add a replacestring filter.
      Parameters:
        `filter` - a `TokenFilter.ReplaceString` value
      Since:
        Ant 1.6

    - #### addIgnoreBlank

          public void addIgnoreBlank​(TokenFilter.IgnoreBlank filter)

      Add an ignoreBlank filter.
      Parameters:
        `filter` - a `TokenFilter.IgnoreBlank` value
      Since:
        Ant 1.6

    - #### setRefid

          public void setRefid​(Reference r)
                        throws BuildException

      Makes this instance in effect a reference to another FilterChain instance.

      You must not set another attribute or nest elements inside this element if you make it a reference.

      Overrides:
        `setRefid` in class `DataType`
      Parameters:
        `r` - the reference to which this instance is associated
      Throws:
        `BuildException` - if this instance already has been configured.

    - #### add

          public void add​(ChainableReader filter)

      Add a chainfilter filter.
      Parameters:
        `filter` - a `ChainableReader` value
      Since:
        Ant 1.6

    - #### dieOnCircularReference

          protected void dieOnCircularReference​(java.util.Stack<java.lang.Object> stk,
                                                Project p)
                                         throws BuildException

      Description copied from class: `DataType`
      Check to see whether any DataType we hold references to is included in the Stack (which holds all DataType instances that directly or indirectly reference this instance, including this instance itself).

      If one is included, throw a BuildException created by `circularReference`.

      This implementation is appropriate only for a DataType that cannot hold other DataTypes as children.

      The general contract of this method is that it shouldn't do anything if `DataType.checked` is true and set it to true on exit.

      Overrides:
        `dieOnCircularReference` in class `DataType`
      Parameters:
        `stk` - the stack of references to check.
        `p` - the project to use to dereference the references.
      Throws:
        `BuildException` - on error.